#include <iostream>
#include <biorob-cpp/net/dns-sd/Publisher.h>

#include <signal.h>

class Application {
public :
	typedef std::tr1::shared_ptr<Application> Ptr;
	virtual ~Application() {
		std::cout << "Exiting" << std::endl;
	}
	void Run() {
		using namespace net::dnssd;
		d_publisher = PublisherPtr(new Publisher("BiorobCppTestProgram"));
		d_publisher->AddService(IF_UNSPEC,PROTO_UNSPEC,"_bcpp-greeter._tcp",12345);
		d_publisher->EnterMainLoop();
	}
private :
	typedef std::tr1::shared_ptr<net::dnssd::Publisher> PublisherPtr;
	PublisherPtr d_publisher;
};

static Application::Ptr app;

void SigHandler(int);
void SigHandler(int /*s*/) {
	app = Application::Ptr();
}




int main() {
	using namespace net::dnssd;
	signal(SIGINT,&SigHandler);

	int ret = 0;
	try {
		app = Application::Ptr(new Application());
		app->Run();
	} catch (const std::exception & e) {
		std::cerr << "Got excedption : "<< e.what() <<std::endl;
		ret = 1;
	}

	return ret;
}
