/*
 * \file Server.h
 *
 *  \date Oct 16, 2013
 *  \author Alexandre Tuleu
 */

#ifndef BIOROB_CPP_NET_SERVER_H_
#define BIOROB_CPP_NET_SERVER_H_

#include "Socket.h"

namespace net {

class Server {
public:
	enum Type {
		TCP,
		UDP,
	};

	Server(Type type = TCP);
	virtual ~Server();

	void SetMaxPendingConnections(unsigned int max);
	unsigned MaxPendingConnections() const;

	void Listen(const std::string & address = "",
	            unsigned int port = 0);

	Socket::Ptr Accept();

protected :

private :
	void Clean();

	Type           d_type;
	int            d_fd;
	unsigned int   d_maxConnections;
};

} /* namespace net */
#endif /* BIOROB_CPP_NET_SERVER_H_ */
