/*
 * \file TcpSocket.cpp
 *
 *  \date Sep 18, 2013
 *  \author Alexandre Tuleu
 */

#include "TcpSocket.h"

#include <sys/socket.h>
#include <biorob-cpp/os/SystemError.h>
namespace net {

TcpSocket::TcpSocket(int fd){
	EnsureFDSocketIsTcp(fd);
	SetFd(fd);
}

TcpSocket::TcpSocket(const std::string & host,
                     unsigned int port) {
	SetFd(ConnectSocket(host,port,SOCK_STREAM));
}

TcpSocket::~TcpSocket(){
}

void TcpSocket::EnsureFDSocketIsTcp(int fd) {
	if( GetSocketType(fd) != SOCK_STREAM) {
		throw std::logic_error("The socket does not seems to be a TCP Socket");
	}
}

} /* namespace net */
