/*
 * \file UdpSocket.cpp
 *
 *  \date Sep 18, 2013
 *  \author Alexandre Tuleu
 */

#include "UdpSocket.h"

#include <sys/socket.h>

namespace net {

UdpSocket::UdpSocket(int fd){
	EnsureFDSocketIsUDP(fd);
	SetFd(fd);
}

UdpSocket::UdpSocket(const std::string & host,
                     unsigned int port) {
	SetFd(ConnectSocket(host,port,SOCK_DGRAM));
}

UdpSocket::~UdpSocket(){
}

void UdpSocket::EnsureFDSocketIsUDP(int fd) {
	if( GetSocketType(fd) != SOCK_DGRAM ) {
		throw std::logic_error("The socket does not seems to be a UDP Socket");
	}
}


} /* namespace net */
